<?php

namespace InSegment\WorkersFramework\Console\Commands;

use Shavshukov\EventAppBase\Console\AppCommand;

use InSegment\WorkersFramework\Providers\QueueConnectionServiceProvider;
use InSegment\WorkersFramework\Interfaces\ConnectionListInterface;
use InSegment\WorkersFramework\Services\Declarator;

class Declaration extends AppCommand
{
    
    /**
     * {@inheritDoc}
     */
    public function usage(): string
    {
        return 'Declare AMQP queues and exchanges';
    }

    /**
     * {@inheritDoc}
     */
    public function handle(array $arguments)
    {
        $this->app->registerProviders([
            new QueueConnectionServiceProvider($this->app),
        ], $this->app);
        
        return $this->app->service('queue-connections-list')->then(function (ConnectionListInterface $connections) {
            return (new Declarator($this->app, $connections))->declare();
        })->then((function() {
            return $this->app->stop();
        }));
    }

    /**
     * {@inheritDoc}
     */
    public function help(string $entryFileName): string
    {
        return implode("\n", [
            "Usage: {$entryFileName} declare\n",
            'Declare AMQP queues and exchanges'
        ]);
    }
    
}
