<?php

namespace InSegment\WorkersFramework\Interfaces;

interface JobListInterface
{
    
    /**
     * Get an instance of JobConfigInterface by the name of the job
     * 
     * @param string $jobName
     * @return \InSegment\WorkersFramework\Interfaces\JobConfigInterface|null
     */
    public function getJob(string $jobName): ?JobConfigInterface;
    
    /**
     * Get workers the job can be done on
     * 
     * @param string $jobName
     * @return array|null
     */
    public function getJobWorkers(string $jobName): ?array;
    
}
